## org.apache.lucene.index
Class IndexWriter

    java.lang.Object
      org.apache.lucene.index.IndexWriter

    public class IndexWriter

extends Object

An `IndexWriter` creates and maintains an index.

The `create` argument to the constructor determines whether a new index is created, or whether an existing index is opened. Note that you can open an index with `create=true` even while readers are using the index. The old readers will continue to search the "point in time" snapshot they had opened, and won't see the newly created index until they re-open. There are also constructors with no `create` argument which will create a new index if there is not already an index at the provided path and otherwise open the existing index.

In either case, documents are added with addDocument and removed with deleteDocuments. A document can be updated with updateDocument (which just deletes and then adds the entire document). When finished adding, deleting and updating documents, close should be called.

These changes are buffered in memory and periodically flushed to the `Directory` (during the above method calls). A flush is triggered when there are enough buffered deletes (see `setMaxBufferedDeleteTerms(int)`) or enough added documents since the last flush, whichever is sooner. For the added documents, flushing is triggered either by RAM usage of the documents (see `setRAMBufferSizeMB(double)`) or the number of added documents. The default is to flush when RAM usage hits 16 MB. For best indexing speed you should flush by RAM usage with a large RAM buffer. You can also force a flush by calling `flush()`. When a flush occurs, both pending deletes and added documents are flushed to the index. A flush may also trigger one or more segment merges which by default run with a background thread so as not to block the addDocument calls (see below for changing the `MergeScheduler`).

The optional `autoCommit` argument to the constructors controls visibility of the changes to `IndexReader` instances reading the same index. When this is `false`, changes are not visible until `close()` is called. Note that changes will still be flushed to the `Directory` as new files, but are not committed (no new `segments_N` file is written referencing the new files) until `close()` is called. If something goes terribly wrong (for example the JVM crashes) before `close()`, then the index will reflect none of the changes made (it will remain in its starting state). You can also call `abort()`, which closes the writer without committing any changes, and removes any index files that had been flushed but are now unreferenced. This mode is useful for preventing readers from refreshing at a bad time (for example after you've done all your deletes but before you've done your adds). It can also be used to implement simple single-writer transactional semantics ("all or none").

When `autoCommit` is `true` then every flush is also a commit (`IndexReader` instances will see each flush as changes to the index). This is the default, to match the behavior before 2.2. When running in this mode, be careful not to refresh your readers while optimize or segment merges are taking place as this can tie up substantial disk space.

Regardless of `autoCommit`, an `IndexReader` or `IndexSearcher` will only see the index as of the "point in time" that it was opened. Any changes committed to the index after the reader was opened are not visible until the reader is re-opened.

If an index will not have more documents added for a while and optimal search performance is desired, then the optimize method should be called before the index is closed.

Opening an `IndexWriter` creates a lock file for the directory in use. Trying to open another `IndexWriter` on the same directory will lead to a `LockObtainFailedException`. The `LockObtainFailedException` is also thrown if an IndexReader on the same directory is used to delete documents from the index.

Expert: `IndexWriter` allows an optional `IndexDeletionPolicy` implementation to be specified. You can use this to control when prior commits are deleted from the index. The default policy is `KeepOnlyLastCommitDeletionPolicy` which removes all prior commits as soon as a new commit is done (this matches behavior before 2.2). Creating your own policy can allow you to explicitly keep previous "point in time" commits alive in the index for some time, to allow readers to refresh to the new commit without having the old commit deleted out from under them. This is necessary on filesystems like NFS that do not support "delete on last close" semantics, which Lucene's "point in time" search normally relies on.

Expert: `IndexWriter` allows you to separately change the `MergePolicy` and the `MergeScheduler`. The `MergePolicy` is invoked whenever there are changes to the segments in the index. Its role is to select which merges to do, if any, and return a `MergePolicy.MergeSpecification` describing the merges. It also selects merges to do for optimize(). (The default is `LogByteSizeMergePolicy`. Then, the `MergeScheduler` is invoked with the requested merges and it decides when and how to run the merges. The default is `ConcurrentMergeScheduler`.

Field Summary
`static int` `DEFAULT_MAX_BUFFERED_DELETE_TERMS` Disabled by default (because IndexWriter flushes by RAM usage by default).
`static int` `DEFAULT_MAX_BUFFERED_DOCS` Disabled by default (because IndexWriter flushes by RAM usage by default).
`static int` `DEFAULT_MAX_FIELD_LENGTH` Default value is 10,000.
`static int` `DEFAULT_MAX_MERGE_DOCS` Deprecated.
`static int` `DEFAULT_MERGE_FACTOR` Deprecated.
`static double` `DEFAULT_RAM_BUFFER_SIZE_MB` Default value is 16 MB (which means flush when buffered docs consume 16 MB RAM).
`static int` `DEFAULT_TERM_INDEX_INTERVAL` Default value is 128.
`static int` `DISABLE_AUTO_FLUSH` Value to denote a flush trigger is disabled
`static int` `MAX_TERM_LENGTH` Absolute hard maximum length for a term.
`static String` `WRITE_LOCK_NAME` Name of the write lock in the index.
`static long` `WRITE_LOCK_TIMEOUT` Default value for the write lock timeout (1,000).

Constructor Summary
`IndexWriter(Directory d, Analyzer a)` Constructs an IndexWriter for the index in `d`, first creating it if it does not already exist.
`IndexWriter(Directory d, Analyzer a, boolean create)` Constructs an IndexWriter for the index in `d`.
`IndexWriter(Directory d, boolean autoCommit, Analyzer a)` Constructs an IndexWriter for the index in `d`, first creating it if it does not already exist.
`IndexWriter(Directory d, boolean autoCommit, Analyzer a, boolean create)` Constructs an IndexWriter for the index in `d`.
`IndexWriter(Directory d, boolean autoCommit, Analyzer a, boolean create, IndexDeletionPolicy deletionPolicy)` Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`.
`IndexWriter(Directory d, boolean autoCommit, Analyzer a, IndexDeletionPolicy deletionPolicy)` Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`, first creating it if it does not already exist.
`IndexWriter(File path, Analyzer a)` Constructs an IndexWriter for the index in `path`, first creating it if it does not already exist.
`IndexWriter(File path, Analyzer a, boolean create)` Constructs an IndexWriter for the index in `path`.
`IndexWriter(String path, Analyzer a)` Constructs an IndexWriter for the index in `path`, first creating it if it does not already exist.
`IndexWriter(String path, Analyzer a, boolean create)` Constructs an IndexWriter for the index in `path`.

Method Summary
`void` `abort()` Close the `IndexWriter` without committing any of the changes that have occurred since it was opened.
`void` `addDocument(Document doc)` Adds a document to this index.
`void` `addDocument(Document doc, Analyzer analyzer)` Adds a document to this index, using the provided analyzer instead of the value of `getAnalyzer()`.
`void` `addIndexes(Directory[] dirs)` Merges all segments from an array of indexes into this index.
`void` `addIndexes(IndexReader[] readers)` Merges the provided indexes into this index.
`void` `addIndexesNoOptimize(Directory[] dirs)` Merges all segments from an array of indexes into this index.
`void` `close()` Flushes all changes to an index and closes all associated files.
`void` `close(boolean waitForMerges)` Closes the index with or without waiting for currently running merges to finish.
`void` `deleteDocuments(Term term)` Deletes the document(s) containing `term`.
`void` `deleteDocuments(Term[] terms)` Deletes the document(s) containing any of the terms.
`int` `docCount()` Returns the number of documents currently in this index.
`protected void` `ensureOpen()` Used internally to throw an `AlreadyClosedException` if this IndexWriter has been closed.
`protected void` `finalize()` Release the write lock, if needed.
`void` `flush()` Flush all in-memory buffered updates (adds and deletes) to the Directory.
`protected void` `flush(boolean triggerMerge, boolean flushDocStores)` Flush all in-memory buffered udpates (adds and deletes) to the Directory.
`Analyzer` `getAnalyzer()` Returns the analyzer used by this index.
`static PrintStream` `getDefaultInfoStream()` Returns the current default infoStream for newly instantiated IndexWriters.
`static long` `getDefaultWriteLockTimeout()` Returns default write lock timeout for newly instantiated IndexWriters.
`Directory` `getDirectory()` Returns the Directory used by this index.
`PrintStream` `getInfoStream()` Returns the current infoStream in use by this writer.
`int` `getMaxBufferedDeleteTerms()` Returns the number of buffered deleted terms that will trigger a flush if enabled.
`int` `getMaxBufferedDocs()` Returns the number of buffered added documents that will trigger a flush if enabled.
`int` `getMaxFieldLength()` Returns the maximum number of terms that will be indexed for a single field in a document.
`int` `getMaxMergeDocs()` Returns the largest segment (measured by document count) that may be merged with other segments.
`int` `getMergeFactor()` Returns the number of segments that are merged at once and also controls the total number of segments allowed to accumulate in the index.
`MergePolicy` `getMergePolicy()` Expert: returns the current MergePolicy in use by this writer.
`MergeScheduler` `getMergeScheduler()` Expert: returns the current MergePolicy in use by this writer.
`double` `getRAMBufferSizeMB()` Returns the value set by `setRAMBufferSizeMB(double)` if enabled.
`Similarity` `getSimilarity()` Expert: Return the Similarity implementation used by this IndexWriter.
`int` `getTermIndexInterval()` Expert: Return the interval between indexed terms.
`boolean` `getUseCompoundFile()` Get the current setting of whether newly flushed segments will use the compound file format.
`long` `getWriteLockTimeout()` Returns allowed timeout when acquiring the write lock.
`void` `maybeMerge()` Expert: asks the mergePolicy whether any merges are necessary now and if so, runs the requested merges and then iterate (test again if merges are needed) until no more merges are returned by the mergePolicy.
`void` `message(String message)` Prints a message to the infoStream (if non-null), prefixed with the identifying information for this writer and the thread that's calling it.
`int` `numRamDocs()` Expert: Return the number of documents whose segments are currently cached in memory.
`void` `optimize()` Requests an "optimize" operation on an index, priming the index for the fastest available search.
`void` `optimize(boolean doWait)` Just like `optimize()`, except you can specify whether the call should block until the optimize completes.
`void` `optimize(int maxNumSegments)` Optimize the index down to <= maxNumSegments.
`void` `optimize(int maxNumSegments, boolean doWait)` Just like `optimize(int)`, except you can specify whether the call should block until the optimize completes.
`long` `ramSizeInBytes()` Expert: Return the total size of all index files currently cached in memory.
`String` `segString()`
`static void` `setDefaultInfoStream(PrintStream infoStream)` If non-null, this will be the default infoStream used by a newly instantiated IndexWriter.
`static void` `setDefaultWriteLockTimeout(long writeLockTimeout)` Sets the default (for any instance of IndexWriter) maximum time to wait for a write lock (in milliseconds).
`void` `setInfoStream(PrintStream infoStream)` If non-null, information about merges, deletes and a message when maxFieldLength is reached will be printed to this.
`void` `setMaxBufferedDeleteTerms(int maxBufferedDeleteTerms)` Determines the minimal number of delete terms required before the buffered in-memory delete terms are applied and flushed.
`void` `setMaxBufferedDocs(int maxBufferedDocs)` Determines the minimal number of documents required before the buffered in-memory documents are flushed as a new Segment.
`void` `setMaxFieldLength(int maxFieldLength)` The maximum number of terms that will be indexed for a single field in a document.
`void` `setMaxMergeDocs(int maxMergeDocs)` Determines the largest segment (measured by document count) that may be merged with other segments.
`void` `setMergeFactor(int mergeFactor)` Determines how often segment indices are merged by addDocument().
`void` `setMergePolicy(MergePolicy mp)` Expert: set the merge policy used by this writer.
`void` `setMergeScheduler(MergeScheduler mergeScheduler)` Expert: set the merge scheduler used by this writer.
`void` `setRAMBufferSizeMB(double mb)` Determines the amount of RAM that may be used for buffering added documents before they are flushed as a new Segment.
`void` `setSimilarity(Similarity similarity)` Expert: Set the Similarity implementation used by this IndexWriter.
`void` `setTermIndexInterval(int interval)` Expert: Set the interval between indexed terms.
`void` `setUseCompoundFile(boolean value)` Setting to turn on usage of a compound file.
`void` `setWriteLockTimeout(long writeLockTimeout)` Sets the maximum time to wait for a write lock (in milliseconds) for this instance of IndexWriter.
`void` `updateDocument(Term term, Document doc)` Updates a document by first deleting the document(s) containing `term` and then adding the new document.
`void` `updateDocument(Term term, Document doc, Analyzer analyzer)` Updates a document by first deleting the document(s) containing `term` and then adding the new document.

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### WRITE_LOCK_TIMEOUT

    public static long WRITE_LOCK_TIMEOUT

  Default value for the write lock timeout (1,000).

  See Also:
    `setDefaultWriteLockTimeout(long)`

### WRITE_LOCK_NAME

    public static final String WRITE_LOCK_NAME

  Name of the write lock in the index.

  See Also:
    Constant Field Values

### DEFAULT_MERGE_FACTOR

    public static final int DEFAULT_MERGE_FACTOR

  Deprecated.
  See Also:
    `LogMergePolicy.DEFAULT_MERGE_FACTOR`, Constant Field Values

### DISABLE_AUTO_FLUSH

    public static final int DISABLE_AUTO_FLUSH

  Value to denote a flush trigger is disabled

  See Also:
    Constant Field Values

### DEFAULT_MAX_BUFFERED_DOCS

    public static final int DEFAULT_MAX_BUFFERED_DOCS

  Disabled by default (because IndexWriter flushes by RAM usage by default). Change using `setMaxBufferedDocs(int)`.

  See Also:
    Constant Field Values

### DEFAULT_RAM_BUFFER_SIZE_MB

    public static final double DEFAULT_RAM_BUFFER_SIZE_MB

  Default value is 16 MB (which means flush when buffered docs consume 16 MB RAM). Change using `setRAMBufferSizeMB(double)`.

  See Also:
    Constant Field Values

### DEFAULT_MAX_BUFFERED_DELETE_TERMS

    public static final int DEFAULT_MAX_BUFFERED_DELETE_TERMS

  Disabled by default (because IndexWriter flushes by RAM usage by default). Change using `setMaxBufferedDeleteTerms(int)`.

  See Also:
    Constant Field Values

### DEFAULT_MAX_MERGE_DOCS

    public static final int DEFAULT_MAX_MERGE_DOCS

  Deprecated.
  See Also:
    `LogMergePolicy.DEFAULT_MAX_MERGE_DOCS`, Constant Field Values

### DEFAULT_MAX_FIELD_LENGTH

    public static final int DEFAULT_MAX_FIELD_LENGTH

  Default value is 10,000. Change using `setMaxFieldLength(int)`.

  See Also:
    Constant Field Values

### DEFAULT_TERM_INDEX_INTERVAL

    public static final int DEFAULT_TERM_INDEX_INTERVAL

  Default value is 128. Change using `setTermIndexInterval(int)`.

  See Also:
    Constant Field Values

### MAX_TERM_LENGTH

    public static final int MAX_TERM_LENGTH

  Absolute hard maximum length for a term. If a term arrives from the analyzer longer than this length, it is skipped and a message is printed to infoStream, if set (see `setInfoStream(java.io.PrintStream)`).

Constructor Detail

### IndexWriter

    public IndexWriter(String path,
                       Analyzer a,
                       boolean create)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Constructs an IndexWriter for the index in `path`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `path`, replacing the index already there, if any.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(File path,
                       Analyzer a,
                       boolean create)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Constructs an IndexWriter for the index in `path`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `path`, replacing the index already there, if any.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a,
                       boolean create)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Constructs an IndexWriter for the index in `d`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `d`, replacing the index already there, if any.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(String path,
                       Analyzer a)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Constructs an IndexWriter for the index in `path`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(File path,
                       Analyzer a)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Constructs an IndexWriter for the index in `path`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `path` - the path to the index directory
    `a` - the analyzer to use
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       Analyzer a)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Constructs an IndexWriter for the index in `d`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `d` - the index directory
    `a` - the analyzer to use
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       boolean autoCommit,
                       Analyzer a)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Constructs an IndexWriter for the index in `d`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `d` - the index directory
    `autoCommit` - see above
    `a` - the analyzer to use
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       boolean autoCommit,
                       Analyzer a,
                       boolean create)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Constructs an IndexWriter for the index in `d`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `d`, replacing the index already there, if any.

  Parameters:
    `d` - the index directory
    `autoCommit` - see above
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       boolean autoCommit,
                       Analyzer a,
                       IndexDeletionPolicy deletionPolicy)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`, first creating it if it does not already exist. Text will be analyzed with `a`.

  Parameters:
    `d` - the index directory
    `autoCommit` - see above
    `a` - the analyzer to use
    `deletionPolicy` - see above
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to or if there is any other low-level IO error

### IndexWriter

    public IndexWriter(Directory d,
                       boolean autoCommit,
                       Analyzer a,
                       boolean create,
                       IndexDeletionPolicy deletionPolicy)
                throws CorruptIndexException,
                       LockObtainFailedException,
                       IOException

  Expert: constructs an IndexWriter with a custom `IndexDeletionPolicy`, for the index in `d`. Text will be analyzed with `a`. If `create` is true, then a new, empty index will be created in `d`, replacing the index already there, if any.

  Parameters:
    `d` - the index directory
    `autoCommit` - see above
    `a` - the analyzer to use
    `create` - `true` to create the index or overwrite the existing one; `false` to append to the existing index
    `deletionPolicy` - see above
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `LockObtainFailedException` - if another writer has this index open (`write.lock` could not be obtained)
    `IOException` - if the directory cannot be read/written to, or if it does not exist and `create` is `false` or if there is any other low-level IO error

Method Detail

### ensureOpen

    protected final void ensureOpen()
                             throws AlreadyClosedException

  Used internally to throw an `AlreadyClosedException` if this IndexWriter has been closed.

  Throws:
    `AlreadyClosedException` - if this IndexWriter is

### message

    public void message(String message)

  Prints a message to the infoStream (if non-null), prefixed with the identifying information for this writer and the thread that's calling it.

### getUseCompoundFile

    public boolean getUseCompoundFile()

  Get the current setting of whether newly flushed segments will use the compound file format. Note that this just returns the value previously set with setUseCompoundFile(boolean), or the default value (true). You cannot use this to query the status of previously flushed segments.

  Note that this method is a convenience method: it just calls mergePolicy.getUseCompoundFile as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  See Also:
    `setUseCompoundFile(boolean)`

### setUseCompoundFile

    public void setUseCompoundFile(boolean value)

  Setting to turn on usage of a compound file. When on, multiple files for each segment are merged into a single file when a new segment is flushed.

  Note that this method is a convenience method: it just calls mergePolicy.setUseCompoundFile as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

### setSimilarity

    public void setSimilarity(Similarity similarity)

  Expert: Set the Similarity implementation used by this IndexWriter.

  See Also:
    `Similarity.setDefault(Similarity)`

### getSimilarity

    public Similarity getSimilarity()

  Expert: Return the Similarity implementation used by this IndexWriter.

  This defaults to the current value of `Similarity.getDefault()`.

### setTermIndexInterval

    public void setTermIndexInterval(int interval)

  Expert: Set the interval between indexed terms. Large values cause less memory to be used by IndexReader, but slow random-access to terms. Small values cause more memory to be used by an IndexReader, and speed random-access to terms. This parameter determines the amount of computation required per query term, regardless of the number of documents that contain that term. In particular, it is the maximum number of other terms that must be scanned before a term is located and its frequency and position information may be processed. In a large index with user-entered query terms, query processing time is likely to be dominated not by term lookup but rather by the processing of frequency and positional data. In a small index or when many uncommon query terms are generated (e.g., by wildcard queries) term lookup may become a dominant cost. In particular, `numUniqueTerms/interval` terms are read into memory by an IndexReader, and, on average, `interval/2` terms must be scanned for each random term access.

  See Also:
    `DEFAULT_TERM_INDEX_INTERVAL`

### getTermIndexInterval

    public int getTermIndexInterval()

  Expert: Return the interval between indexed terms.

  See Also:
    `setTermIndexInterval(int)`

### setMergePolicy

    public void setMergePolicy(MergePolicy mp)

  Expert: set the merge policy used by this writer.

### getMergePolicy

    public MergePolicy getMergePolicy()

  Expert: returns the current MergePolicy in use by this writer.

  See Also:
    `setMergePolicy(org.apache.lucene.index.MergePolicy)`

### setMergeScheduler

    public void setMergeScheduler(MergeScheduler mergeScheduler)
                           throws CorruptIndexException,
                                  IOException

  Expert: set the merge scheduler used by this writer.

  Throws:
    `CorruptIndexException`
    `IOException`

### getMergeScheduler

    public MergeScheduler getMergeScheduler()

  Expert: returns the current MergePolicy in use by this writer.

  See Also:
    `setMergePolicy(org.apache.lucene.index.MergePolicy)`

### setMaxMergeDocs

    public void setMaxMergeDocs(int maxMergeDocs)

  Determines the largest segment (measured by document count) that may be merged with other segments. Small values (e.g., less than 10,000) are best for interactive indexing, as this limits the length of pauses while indexing to a few seconds. Larger values are best for batched indexing and speedier searches.

  The default value is `Integer.MAX_VALUE`.

  Note that this method is a convenience method: it just calls mergePolicy.setMaxMergeDocs as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  The default merge policy (`LogByteSizeMergePolicy`) also allows you to set this limit by net size (in MB) of the segment, using `LogByteSizeMergePolicy.setMaxMergeMB(double)`.

### getMaxMergeDocs

    public int getMaxMergeDocs()

  Returns the largest segment (measured by document count) that may be merged with other segments.

  Note that this method is a convenience method: it just calls mergePolicy.getMaxMergeDocs as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  See Also:
    `setMaxMergeDocs(int)`

### setMaxFieldLength

    public void setMaxFieldLength(int maxFieldLength)

  The maximum number of terms that will be indexed for a single field in a document. This limits the amount of memory required for indexing, so that collections with very large files will not crash the indexing process by running out of memory. This setting refers to the number of running terms, not to the number of different terms.

  Note: this silently truncates large documents, excluding from the index all terms that occur further in the document. If you know your source documents are large, be sure to set this value high enough to accomodate the expected size. If you set it to Integer.MAX_VALUE, then the only limit is your memory, but you should anticipate an OutOfMemoryError.

  By default, no more than 10,000 terms will be indexed for a field.

### getMaxFieldLength

    public int getMaxFieldLength()

  Returns the maximum number of terms that will be indexed for a single field in a document.

  See Also:
    `setMaxFieldLength(int)`

### setMaxBufferedDocs

    public void setMaxBufferedDocs(int maxBufferedDocs)

  Determines the minimal number of documents required before the buffered in-memory documents are flushed as a new Segment. Large values generally gives faster indexing.

  When this is set, the writer will flush every maxBufferedDocs added documents. Pass in `DISABLE_AUTO_FLUSH` to prevent triggering a flush due to number of buffered documents. Note that if flushing by RAM usage is also enabled, then the flush will be triggered by whichever comes first.

  Disabled by default (writer flushes by RAM usage).

  Throws:
    `IllegalArgumentException` - if maxBufferedDocs is enabled but smaller than 2, or it disables maxBufferedDocs when ramBufferSize is already disabled
  See Also:
    `setRAMBufferSizeMB(double)`

### getMaxBufferedDocs

    public int getMaxBufferedDocs()

  Returns the number of buffered added documents that will trigger a flush if enabled.

  See Also:
    `setMaxBufferedDocs(int)`

### setRAMBufferSizeMB

    public void setRAMBufferSizeMB(double mb)

  Determines the amount of RAM that may be used for buffering added documents before they are flushed as a new Segment. Generally for faster indexing performance it's best to flush by RAM usage instead of document count and use as large a RAM buffer as you can.

  When this is set, the writer will flush whenever buffered documents use this much RAM. Pass in `DISABLE_AUTO_FLUSH` to prevent triggering a flush due to RAM usage. Note that if flushing by document count is also enabled, then the flush will be triggered by whichever comes first.

  The default value is `DEFAULT_RAM_BUFFER_SIZE_MB`.

  Throws:
    `IllegalArgumentException` - if ramBufferSize is enabled but non-positive, or it disables ramBufferSize when maxBufferedDocs is already disabled

### getRAMBufferSizeMB

    public double getRAMBufferSizeMB()

  Returns the value set by `setRAMBufferSizeMB(double)` if enabled.

### setMaxBufferedDeleteTerms

    public void setMaxBufferedDeleteTerms(int maxBufferedDeleteTerms)

  Determines the minimal number of delete terms required before the buffered in-memory delete terms are applied and flushed. If there are documents buffered in memory at the time, they are merged and a new segment is created.

  Disabled by default (writer flushes by RAM usage).

  Throws:
    `IllegalArgumentException` - if maxBufferedDeleteTerms is enabled but smaller than 1
  See Also:
    `setRAMBufferSizeMB(double)`

### getMaxBufferedDeleteTerms

    public int getMaxBufferedDeleteTerms()

  Returns the number of buffered deleted terms that will trigger a flush if enabled.

  See Also:
    `setMaxBufferedDeleteTerms(int)`

### setMergeFactor

    public void setMergeFactor(int mergeFactor)

  Determines how often segment indices are merged by addDocument(). With smaller values, less RAM is used while indexing, and searches on unoptimized indices are faster, but indexing speed is slower. With larger values, more RAM is used during indexing, and while searches on unoptimized indices are slower, indexing is faster. Thus larger values (> 10) are best for batch index creation, and smaller values (< 10) for indices that are interactively maintained.

  Note that this method is a convenience method: it just calls mergePolicy.setMergeFactor as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  This must never be less than 2. The default value is 10.

### getMergeFactor

    public int getMergeFactor()

  Returns the number of segments that are merged at once and also controls the total number of segments allowed to accumulate in the index.

  Note that this method is a convenience method: it just calls mergePolicy.getMergeFactor as long as mergePolicy is an instance of `LogMergePolicy`. Otherwise an IllegalArgumentException is thrown.

  See Also:
    `setMergeFactor(int)`

### setDefaultInfoStream

    public static void setDefaultInfoStream(PrintStream infoStream)

  If non-null, this will be the default infoStream used by a newly instantiated IndexWriter.

  See Also:
    `setInfoStream(java.io.PrintStream)`

### getDefaultInfoStream

    public static PrintStream getDefaultInfoStream()

  Returns the current default infoStream for newly instantiated IndexWriters.

  See Also:
    `setDefaultInfoStream(java.io.PrintStream)`

### setInfoStream

    public void setInfoStream(PrintStream infoStream)

  If non-null, information about merges, deletes and a message when maxFieldLength is reached will be printed to this.

### getInfoStream

    public PrintStream getInfoStream()

  Returns the current infoStream in use by this writer.

  See Also:
    `setInfoStream(java.io.PrintStream)`

### setWriteLockTimeout

    public void setWriteLockTimeout(long writeLockTimeout)

  Sets the maximum time to wait for a write lock (in milliseconds) for this instance of IndexWriter. @see

  See Also:
    `to change the default value for all instances of IndexWriter.`

### getWriteLockTimeout

    public long getWriteLockTimeout()

  Returns allowed timeout when acquiring the write lock.

  See Also:
    `setWriteLockTimeout(long)`

### setDefaultWriteLockTimeout

    public static void setDefaultWriteLockTimeout(long writeLockTimeout)

  Sets the default (for any instance of IndexWriter) maximum time to wait for a write lock (in milliseconds).

### getDefaultWriteLockTimeout

    public static long getDefaultWriteLockTimeout()

  Returns default write lock timeout for newly instantiated IndexWriters.

  See Also:
    `setDefaultWriteLockTimeout(long)`

### close

    public void close()
               throws CorruptIndexException,
                      IOException

  Flushes all changes to an index and closes all associated files.

  If an Exception is hit during close, eg due to disk full or some other reason, then both the on-disk index and the internal state of the IndexWriter instance will be consistent. However, the close will not be complete even though part of it (flushing buffered documents) may have succeeded, so the write lock will still be held.

  If you can correct the underlying cause (eg free up some disk space) then you can call close() again. Failing that, if you want to force the write lock to be released (dangerous, because you may then lose buffered docs in the IndexWriter instance) then you can do something like this:

       try {
         writer.close();
       } finally {
         if (IndexReader.isLocked(directory)) {
           IndexReader.unlock(directory);
         }
       }

  after which, you must be certain not to use the writer instance anymore.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### close

    public void close(boolean waitForMerges)
               throws CorruptIndexException,
                      IOException

  Closes the index with or without waiting for currently running merges to finish. This is only meaningful when using a MergeScheduler that runs merges in background threads.

  Parameters:
    `waitForMerges` - if true, this call will block until all merges complete; else, it will ask all running merges to abort, wait until those merges have finished (which should be at most a few seconds), and then return.
  Throws:
    `CorruptIndexException`
    `IOException`

### finalize

    protected void finalize()
                     throws Throwable

  Release the write lock, if needed.

  Overrides:
    `finalize` in class `Object`
  Throws:
    `Throwable`

### getDirectory

    public Directory getDirectory()

  Returns the Directory used by this index.

### getAnalyzer

    public Analyzer getAnalyzer()

  Returns the analyzer used by this index.

### docCount

    public int docCount()

  Returns the number of documents currently in this index.

### addDocument

    public void addDocument(Document doc)
                     throws CorruptIndexException,
                            IOException

  Adds a document to this index. If the document contains more than `setMaxFieldLength(int)` terms for a given field, the remainder are discarded.

  Note that if an Exception is hit (for example disk full) then the index will be consistent, but this document may not have been added. Furthermore, it's possible the index will have one segment in non-compound format even when using compound files (when a merge has partially succeeded).

  This method periodically flushes pending documents to the Directory (every `setMaxBufferedDocs(int)`), and also periodically merges segments in the index (every `setMergeFactor(int)` flushes). When this occurs, the method will take more time to run (possibly a long time if the index is large), and will require free temporary space in the Directory to do the merging.

  The amount of free space required when a merge is triggered is up to 1X the size of all segments being merged, when no readers/searchers are open against the index, and up to 2X the size of all segments being merged when readers/searchers are open against the index (see `optimize()` for details). The sequence of primitive merge operations performed is governed by the merge policy.

  Note that each term in the document can be no longer than 16383 characters, otherwise an IllegalArgumentException will be thrown.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### addDocument

    public void addDocument(Document doc,
                            Analyzer analyzer)
                     throws CorruptIndexException,
                            IOException

  Adds a document to this index, using the provided analyzer instead of the value of `getAnalyzer()`. If the document contains more than `setMaxFieldLength(int)` terms for a given field, the remainder are discarded.

  See `addDocument(Document)` for details on index and IndexWriter state after an Exception, and flushing/merging temporary free space requirements.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### deleteDocuments

    public void deleteDocuments(Term term)
                         throws CorruptIndexException,
                                IOException

  Deletes the document(s) containing `term`.

  Parameters:
    `term` - the term to identify the documents to be deleted
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### deleteDocuments

    public void deleteDocuments(Term[] terms)
                         throws CorruptIndexException,
                                IOException

  Deletes the document(s) containing any of the terms. All deletes are flushed at the same time.

  Parameters:
    `terms` - array of terms to identify the documents to be deleted
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### updateDocument

    public void updateDocument(Term term,
                               Document doc)
                        throws CorruptIndexException,
                               IOException

  Updates a document by first deleting the document(s) containing `term` and then adding the new document. The delete and then add are atomic as seen by a reader on the same index (flush may happen only after the add).

  Parameters:
    `term` - the term to identify the document(s) to be deleted
    `doc` - the document to be added
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### updateDocument

    public void updateDocument(Term term,
                               Document doc,
                               Analyzer analyzer)
                        throws CorruptIndexException,
                               IOException

  Updates a document by first deleting the document(s) containing `term` and then adding the new document. The delete and then add are atomic as seen by a reader on the same index (flush may happen only after the add).

  Parameters:
    `term` - the term to identify the document(s) to be deleted
    `doc` - the document to be added
    `analyzer` - the analyzer to use when analyzing the document
  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### optimize

    public void optimize()
                  throws CorruptIndexException,
                         IOException

  Requests an "optimize" operation on an index, priming the index for the fastest available search. Traditionally this has meant merging all segments into a single segment as is done in the default merge policy, but individaul merge policies may implement optimize in different ways.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error
  See Also:
    `

    It is recommended that this method be called upon completion of indexing. In environments with frequent updates, optimize is best done during low volume times, if at all.

    See http://www.gossamer-threads.com/lists/lucene/java-dev/47895 for more discussion.

    Note that this can require substantial temporary free space in the Directory (see LUCENE-764 for details):

    - If no readers/searchers are open against the index, then free space required is up to 1X the total size of the starting index. For example, if the starting index is 10 GB, then you must have up to 10 GB of free space before calling optimize.

    - If readers/searchers are using the index, then free space required is up to 2X the size of the starting index. This is because in addition to the 1X used by optimize, the original 1X of the starting index is still consuming space in the Directory as the readers are holding the segments files open. Even on Unix, where it will appear as if the files are gone ("ls" won't list them), they still consume storage due to "delete on last close" semantics.

      Furthermore, if some but not all readers re-open while the optimize is underway, this will cause > 2X temporary space to be consumed as those new readers will then hold open the partially optimized segments at that time. It is best not to re-open readers while optimize is running.

    The actual temporary usage could be much less than these figures (it depends on many factors).

    In general, once the optimize completes, the total size of the index will be less than the size of the starting index. It could be quite a bit smaller (if there were many pending deletes) or just slightly smaller.

    If an Exception is hit during optimize(), for example due to disk full, the index will not be corrupt and no documents will have been lost. However, it may have been partially optimized (some segments were merged but not all), and it's possible that one of the segments in the index will be in non-compound format even when using compound file format. This will occur when the Exception is hit during conversion of the segment into compound format.

    This call will optimize those segments present in the index when the call started. If other threads are still adding documents and flushing segments, those newly created segments will not be optimized unless you call optimize again.

    `

### optimize

    public void optimize(int maxNumSegments)
                  throws CorruptIndexException,
                         IOException

  Optimize the index down to <= maxNumSegments. If maxNumSegments==1 then this is the same as `optimize()`.

  Parameters:
    `maxNumSegments` - maximum number of segments left in the index after optimization finishes
  Throws:
    `CorruptIndexException`
    `IOException`

### optimize

    public void optimize(boolean doWait)
                  throws CorruptIndexException,
                         IOException

  Just like `optimize()`, except you can specify whether the call should block until the optimize completes. This is only meaningful with a `MergeScheduler` that is able to run merges in background threads.

  Throws:
    `CorruptIndexException`
    `IOException`

### optimize

    public void optimize(int maxNumSegments,
                         boolean doWait)
                  throws CorruptIndexException,
                         IOException

  Just like `optimize(int)`, except you can specify whether the call should block until the optimize completes. This is only meaningful with a `MergeScheduler` that is able to run merges in background threads.

  Throws:
    `CorruptIndexException`
    `IOException`

### maybeMerge

    public final void maybeMerge()
                          throws CorruptIndexException,
                                 IOException

  Expert: asks the mergePolicy whether any merges are necessary now and if so, runs the requested merges and then iterate (test again if merges are needed) until no more merges are returned by the mergePolicy. Explicit calls to maybeMerge() are usually not necessary. The most common case is when merge policy parameters have changed.

  Throws:
    `CorruptIndexException`
    `IOException`

### abort

    public void abort()
               throws IOException

  Close the `IndexWriter` without committing any of the changes that have occurred since it was opened. This removes any temporary files that had been created, after which the state of the index will be the same as it was when this writer was first opened. This can only be called when this IndexWriter was opened with `autoCommit=false`.

  Throws:
    `IllegalStateException` - if this is called when the writer was opened with `autoCommit=true`.
    `IOException` - if there is a low-level IO error

### addIndexes

    public void addIndexes(Directory[] dirs)
                    throws CorruptIndexException,
                           IOException

  Merges all segments from an array of indexes into this index.

  This may be used to parallelize batch indexing. A large document collection can be broken into sub-collections. Each sub-collection can be indexed in parallel, on a different thread, process or machine. The complete index can then be created by merging sub-collection indexes with this method.

  NOTE: the index in each Directory must not be changed (opened by a writer) while this method is running. This method does not acquire a write lock in each input Directory, so it is up to the caller to enforce this.

  NOTE: while this is running, any attempts to add or delete documents (with another thread) will be paused until this method completes.

  After this completes, the index is optimized.

  This method is transactional in how Exceptions are handled: it does not commit a new segments_N file until all indexes are added. This means if an Exception occurs (for example disk full), then either no indexes will have been added or they all will have been.

  If an Exception is hit, it's still possible that all indexes were successfully added. This happens when the Exception is hit when trying to build a CFS file. In this case, one segment in the index will be in non-CFS format, even when using compound file format.

  Also note that on an Exception, the index may still have been partially or fully optimized even though none of the input indexes were added.

  Note that this requires temporary free space in the Directory up to 2X the sum of all input indexes (including the starting index). If readers/searchers are open against the starting index, then temporary free space required will be higher by the size of the starting index (see `optimize()` for details).

  Once this completes, the final size of the index will be less than the sum of all input index sizes (including the starting index). It could be quite a bit smaller (if there were many pending deletes) or just slightly smaller.

  See LUCENE-702 for details.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### addIndexesNoOptimize

    public void addIndexesNoOptimize(Directory[] dirs)
                              throws CorruptIndexException,
                                     IOException

  Merges all segments from an array of indexes into this index.

  This is similar to addIndexes(Directory[]). However, no optimize() is called either at the beginning or at the end. Instead, merges are carried out as necessary.

  NOTE: the index in each Directory must not be changed (opened by a writer) while this method is running. This method does not acquire a write lock in each input Directory, so it is up to the caller to enforce this.

  NOTE: while this is running, any attempts to add or delete documents (with another thread) will be paused until this method completes.

  This requires this index not be among those to be added, and the upper bound* of those segment doc counts not exceed maxMergeDocs.

  See `addIndexes(Directory[])` for details on transactional semantics, temporary free space required in the Directory, and non-CFS segments on an Exception.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### addIndexes

    public void addIndexes(IndexReader[] readers)
                    throws CorruptIndexException,
                           IOException

  Merges the provided indexes into this index.

  After this completes, the index is optimized.

  The provided IndexReaders are not closed.

  NOTE: the index in each Directory must not be changed (opened by a writer) while this method is running. This method does not acquire a write lock in each input Directory, so it is up to the caller to enforce this.

  NOTE: while this is running, any attempts to add or delete documents (with another thread) will be paused until this method completes.

  See `addIndexes(Directory[])` for details on transactional semantics, temporary free space required in the Directory, and non-CFS segments on an Exception.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### flush

    public final void flush()
                     throws CorruptIndexException,
                            IOException

  Flush all in-memory buffered updates (adds and deletes) to the Directory.

  Note: if `autoCommit=false`, flushed data would still not be visible to readers, until `close()` is called.

  Throws:
    `CorruptIndexException` - if the index is corrupt
    `IOException` - if there is a low-level IO error

### flush

    protected final void flush(boolean triggerMerge,
                               boolean flushDocStores)
                        throws CorruptIndexException,
                               IOException

  Flush all in-memory buffered udpates (adds and deletes) to the Directory.

  Parameters:
    `triggerMerge` - if true, we may merge segments (if deletes or docs were flushed) if necessary
    `flushDocStores` - if false we are allowed to keep doc stores open to share with the next segment
  Throws:
    `CorruptIndexException`
    `IOException`

### ramSizeInBytes

    public final long ramSizeInBytes()

  Expert: Return the total size of all index files currently cached in memory. Useful for size management with flushRamDocs()

### numRamDocs

    public final int numRamDocs()

  Expert: Return the number of documents whose segments are currently cached in memory. Useful when calling flush()

### segString

    public String segString()

Copyright © 2000-2008 Apache Software Foundation. All Rights Reserved.